#include <exec/memory.h>
#include <devices/timer.h>
#include <clib/alib_protos.h>
#include <proto/exec.h>

struct PortIO
{
  struct timerequest treq;
  struct MsgPort port;
};

extern inline void NewList(struct List *list)
{
   LONG *p;

   list->lh_TailPred=(struct Node*)list;
   ((LONG *)list)++;
   p=(LONG *)list; *--p=(LONG)list;
}

LONG TimeDelay(long unit, unsigned long secs, unsigned long microsecs)
{
  struct PortIO *portio;
  long ret=-1;

  if ((portio=(struct PortIO *)AllocMem(sizeof(struct PortIO),MEMF_CLEAR|MEMF_PUBLIC)))
  {
    portio->port.mp_Node.ln_Type=NT_MSGPORT;
    if ((BYTE)(portio->port.mp_SigBit=AllocSignal(-1))<0)
    {
      portio->port.mp_SigTask=FindTask(NULL);
      NewList(&portio->port.mp_MsgList);

      portio->treq.tr_node.io_Message.mn_Node.ln_Type=NT_MESSAGE;
      portio->treq.tr_node.io_Message.mn_ReplyPort=&portio->port;
      if (!(OpenDevice(TIMERNAME,unit,&portio->treq.tr_node,0)))
      {
        portio->treq.tr_node.io_Command=TR_ADDREQUEST;
        portio->treq.tr_time.tv_secs=secs;
        portio->treq.tr_time.tv_micro=microsecs;
        if (!DoIO(&portio->treq.tr_node))
          ret=0;
        CloseDevice(&portio->treq.tr_node);
      }
      FreeSignal(portio->port.mp_SigBit);
    }
    FreeMem(portio,sizeof(struct PortIO));
  }
  return ret;
}
